<template>
  <div class="sign-up">
    <nav-bar></nav-bar>
    <div class="columns">
      <aside class="menu column is-2">
        <a class="menu-label" @click="showMenu = !showMenu" style="padding-left: 10px">
          Menu
        </a>
        <ul class="menu-list">
          <li>
            <router-link to="/users">
              <font size="6">Users</font>
            </router-link>
          </li>
          <li>
            <router-link to="/groups">
              <font size="6">Groups</font>
            </router-link>
          </li>
        </ul>
      </aside>
      <table class="table column is-8 is-offset-1 box">
        <thead>
        <label  class="label is-size-4" style="padding-left: 10px; margin-bottom: 0">Groups: </label>
        <tr>
          <th><abbr title="Position">Pos</abbr></th>
          <th>Name</th>
          <th><abbr title="Users">Users</abbr></th>
          <th><abbr title="Read">Read</abbr></th>
          <th><abbr title="Write">Assign Group</abbr></th>
          <th><abbr title="Create">Create</abbr></th>
          <th><abbr title="Delte">Delete</abbr></th>
          <th>Description</th>
        </tr>
        </thead>
        <tfoot>
        <tr>
          <th><abbr title="Position">Pos</abbr></th>
          <th>Name</th>
          <th><abbr title="Users">Users</abbr></th>
          <th><abbr title="Read">Read</abbr></th>
          <th><abbr title="Write">Assign Group</abbr></th>
          <th><abbr title="Create">Create</abbr></th>
          <th><abbr title="Delte">Delete</abbr></th>
          <th>Description</th>
        </tr>
        </tfoot>
        <tbody>
        <tr v-for="(group, index) in groups" v-if="triggeris">
          <th>{{index}}</th>
          <td @click="removeFromTable(index)">{{group.name}}</td>
          <td>404</td>
          <td>{{group.read}}</td>
          <td>{{group.write}}</td>
          <td>{{group.create}}</td>
          <td>{{group.delete}}</td>
          <td>{{group.description}}</td>
          <td><span @click="removeFromTable(index)"><i class="fa fa-trash"></i></span></td>
        </tr>
        </tbody>
      </table>
    </div>
    <div class="columns buttons has-addons is-centered">
      <button id="create_group" class="button is-primary " @click="showModal">Create Group</button>
    </div>

    <div class="modal is-active columns" v-show="show_me">
      <div class="modal-background"></div>
      <div class="modal-content">
        <div class="box">
          <div class="column  is-11">
            <div class="field">
              <div class="control ">
                <div class="columns">
                  <label  class="label column is-size-5 is-3" style="padding-right: 0; margin-right: 0;">Name: </label>
                  <input v-model="new_group.name" style="padding-left: 0; margin-right: 0;" class="input column is-9" type="text" placeholder="New name">
                </div>
              </div>
            </div>
            <div class="columns">
              <div class="field column is-2">
                <div class="control">
                  <label class="checkbox">
                    Read
                    <input id="read" type="checkbox">
                  </label>
                </div>
              </div>
              <div class="field column is-2">
                <div class="control">
                  <label class="checkbox">
                    Write
                    <input id="write" type="checkbox">
                  </label>
                </div>
              </div>
              <div class="field column is-2">
                <div class="control">
                  <label class="checkbox">
                    Create
                    <input id="create" type="checkbox">
                  </label>
                </div>
              </div>
              <div class="field column is-2">
                <div class="control">
                  <label class="checkbox">
                    Delete
                    <input id="delete" type="checkbox">
                  </label>
                </div>
              </div>
            </div>
            <div class="field">
              <label class="label">Description</label>
              <div class="control">
                <textarea class="textarea" v-model="new_group.description" placeholder="Textarea"></textarea>
              </div>
            </div>
            <div class="field is-grouped columns is-centered">
              <div class="control column is-4 is-offset-3">
                <button @click="createGroup" class="button is-info " id="buttn">Create</button>
              </div>
            </div>
          </div>

        </div>
      </div>
      <button class="modal-close is-large" aria-label="close" @click="showModal"></button>
    </div>
  </div>
</template>

<script>
  import firebase from 'firebase'
  import axios from 'axios'
  import Navbar from './Navbar'

  export default {
    name: 'Group',
    data: function() {
      return {
        show_me: false,
        triggeris: true,
        name: '',
        groups: [],
        current_user_id: firebase.auth().currentUser,
        users: '',
        new_group: {
          name: "",
          read: false,
          write: false,
          create: false,
          delete: false,
          description: ""
        },
        showMenu: false
      }
    },
    components: {
      'nav-bar': Navbar,
    },
    methods: {
      showModal() {
        this.show_me = !this.show_me;
      },
      removeFromTable(index) {
        var id = this.groups[index].id
        console.log(id)
        this.groups.splice(index, 1);
        firebase.database().ref("groups/" + id).set(null);
//        console.log(ref)
//        console.log(ref("groups/" + id))
//        axios.post("https://unitask-604a4.firebaseio.com/groups/" + id + '.json', {abc})

      },
      createGroup() {
        this.new_group.read = document.getElementById("read").checked;
        this.new_group.write = document.getElementById("write").checked;
        this.new_group.create = document.getElementById("create").checked;
        this.new_group.delete = document.getElementById("delete").checked;
        axios.post('https://unitask-604a4.firebaseio.com/groups.json', this.new_group);
        this.groups.push(this.new_group)
        this.new_group = {
          name: "",
          read: "",
          write: "",
          create: "",
          delete: "",
          description: ""
        };
        this.showModal()
      }
    },
    mounted () {
      console.log('hello world');
      this.current_user_id = firebase.auth().currentUser;
      axios.get('https://unitask-604a4.firebaseio.com/users.json')
        .then( res => {
          this.users = res.data;
        })
      axios.get('https://unitask-604a4.firebaseio.com/groups.json')
        .then( res => {
          console.log(res.data);
          for(var line in res.data) {
            console.log(line)
            this.groups.push(res.data[line])
            var index = this.groups.length
            this.groups[index - 1].id = line
          }
        })
    },
  }
</script>

<style scoped>
  #create_group {
    margin-bottom: 10px;
  }
</style>
